=begin
#CyberSource Merged Spec

#All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html

OpenAPI spec version: 0.0.1

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.2.3

=end

require 'uri'

module CyberSource
  class PaymentBatchSummariesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default, config)
      @api_client = api_client
	  @api_client.set_configuration(config)
    end
    # Get Payment Batch Summary Data
    # Scope can be either account/merchant or reseller.
    # @param start_time Valid report Start Time in **ISO 8601 format** Please refer the following link to know more about ISO 8601 format.[Rfc Date Format](https://xml2rfc.tools.ietf.org/public/rfc/html/rfc3339.html#anchor14)  **Example date format:**   - yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSSZ (e.g. 2018-01-01T00:00:00.000Z) 
    # @param end_time Valid report End Time in **ISO 8601 format** Please refer the following link to know more about ISO 8601 format.[Rfc Date Format](https://xml2rfc.tools.ietf.org/public/rfc/html/rfc3339.html#anchor14)  **Example date format:**   - yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSSZ (e.g. 2018-01-01T00:00:00.000Z) 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :organization_id Valid Cybersource Organization Id
    # @option opts [String] :roll_up Conditional - RollUp for data for day/week/month. Required while getting breakdown data for a Merchant
    # @option opts [String] :breakdown Conditional - Breakdown on account_rollup/all_merchant/selected_merchant. Required while getting breakdown data for a Merchant.
    # @option opts [Integer] :start_day_of_week Optional - Start day of week to breakdown data for weeks in a month
    # @return [ReportingV3PaymentBatchSummariesGet200Response]
    def get_payment_batch_summary(start_time, end_time, opts = {})
      data, status_code, headers = get_payment_batch_summary_with_http_info(start_time, end_time, opts)
      return data, status_code, headers
    end

    # Get Payment Batch Summary Data
    # Scope can be either account/merchant or reseller.
    # @param start_time Valid report Start Time in **ISO 8601 format** Please refer the following link to know more about ISO 8601 format.[Rfc Date Format](https://xml2rfc.tools.ietf.org/public/rfc/html/rfc3339.html#anchor14)  **Example date format:**   - yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSSZ (e.g. 2018-01-01T00:00:00.000Z) 
    # @param end_time Valid report End Time in **ISO 8601 format** Please refer the following link to know more about ISO 8601 format.[Rfc Date Format](https://xml2rfc.tools.ietf.org/public/rfc/html/rfc3339.html#anchor14)  **Example date format:**   - yyyy-MM-dd&#39;T&#39;HH:mm:ss.SSSZ (e.g. 2018-01-01T00:00:00.000Z) 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :organization_id Valid Cybersource Organization Id
    # @option opts [String] :roll_up Conditional - RollUp for data for day/week/month. Required while getting breakdown data for a Merchant
    # @option opts [String] :breakdown Conditional - Breakdown on account_rollup/all_merchant/selected_merchant. Required while getting breakdown data for a Merchant.
    # @option opts [Integer] :start_day_of_week Optional - Start day of week to breakdown data for weeks in a month
    # @return [Array<(ReportingV3PaymentBatchSummariesGet200Response, Fixnum, Hash)>] ReportingV3PaymentBatchSummariesGet200Response data, response status code and response headers
    def get_payment_batch_summary_with_http_info(start_time, end_time, opts = {})
      
	  if @api_client.config.debugging
	  	begin
			raise
				@api_client.config.logger.debug 'Calling API: PaymentBatchSummariesApi.get_payment_batch_summary ...'
			rescue
				puts 'Cannot write to log'
			end
      end
      # verify the required parameter 'start_time' is set
      if @api_client.config.client_side_validation && start_time.nil?
        fail ArgumentError, "Missing the required parameter 'start_time' when calling PaymentBatchSummariesApi.get_payment_batch_summary"
      end
      # verify the required parameter 'end_time' is set
      if @api_client.config.client_side_validation && end_time.nil?
        fail ArgumentError, "Missing the required parameter 'end_time' when calling PaymentBatchSummariesApi.get_payment_batch_summary"
      end
      if @api_client.config.client_side_validation && !opts[:'organization_id'].nil? && opts[:'organization_id'].to_s.length > 32
        fail ArgumentError, 'invalid value for "opts[:"organization_id"]" when calling PaymentBatchSummariesApi.get_payment_batch_summary, the character length must be smaller than or equal to 32.'
      end

      if @api_client.config.client_side_validation && !opts[:'organization_id'].nil? && opts[:'organization_id'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"organization_id"]" when calling PaymentBatchSummariesApi.get_payment_batch_summary, the character length must be great than or equal to 1.'
      end

      #if @api_client.config.client_side_validation && !opts[:'organization_id'].nil? && opts[:'organization_id'] !~ Regexp.new(/[a-zA-Z0-9-_]+/)
        #fail ArgumentError, "invalid value for 'opts[:\"organization_id\"]' when calling PaymentBatchSummariesApi.get_payment_batch_summary, must conform to the pattern /[a-zA-Z0-9-_]+/."
      #end

      if @api_client.config.client_side_validation && !opts[:'start_day_of_week'].nil? && opts[:'start_day_of_week'] > 7
        fail ArgumentError, 'invalid value for "opts[:"start_day_of_week"]" when calling PaymentBatchSummariesApi.get_payment_batch_summary, must be smaller than or equal to 7.'
      end

      if @api_client.config.client_side_validation && !opts[:'start_day_of_week'].nil? && opts[:'start_day_of_week'] < 1
        fail ArgumentError, 'invalid value for "opts[:"start_day_of_week"]" when calling PaymentBatchSummariesApi.get_payment_batch_summary, must be greater than or equal to 1.'
      end

      # resource path
      local_var_path = 'reporting/v3/payment-batch-summaries'

      # query parameters
      query_params = {}
      query_params[:'startTime'] = start_time
      query_params[:'endTime'] = end_time
      query_params[:'organizationId'] = opts[:'organization_id'] if !opts[:'organization_id'].nil?
      query_params[:'rollUp'] = opts[:'roll_up'] if !opts[:'roll_up'].nil?
      query_params[:'breakdown'] = opts[:'breakdown'] if !opts[:'breakdown'].nil?
      query_params[:'startDayOfWeek'] = opts[:'start_day_of_week'] if !opts[:'start_day_of_week'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/hal+json', 'text/csv', 'application/xml'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json;charset=utf-8'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ReportingV3PaymentBatchSummariesGet200Response')
      if @api_client.config.debugging
		begin
		raise
			@api_client.config.logger.debug "API called: PaymentBatchSummariesApi#get_payment_batch_summary\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
		rescue
			puts 'Cannot write to log'
		end
	  end
      return data, status_code, headers
    end
  end
end
