=begin
#CyberSource Merged Spec

#All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html

OpenAPI spec version: 0.0.1

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.2.3

=end

require 'uri'

module CyberSource
  class PaymentInstrumentApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default, config)
      @api_client = api_client
	  @api_client.set_configuration(config)
    end
    # Delete a Payment Instrument
    # @param payment_instrument_token_id The TokenId of a payment instrument.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :profile_id The id of a profile containing user specific TMS configuration.
    # @return [nil]
    def delete_payment_instrument(payment_instrument_token_id, opts = {})
      data, status_code, headers = delete_payment_instrument_with_http_info(payment_instrument_token_id, opts)
      return data, status_code, headers
    end

    # Delete a Payment Instrument
    # @param payment_instrument_token_id The TokenId of a payment instrument.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :profile_id The id of a profile containing user specific TMS configuration.
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_payment_instrument_with_http_info(payment_instrument_token_id, opts = {})
      
	  if @api_client.config.debugging
	  	begin
			raise
				@api_client.config.logger.debug 'Calling API: PaymentInstrumentApi.delete_payment_instrument ...'
			rescue
				puts 'Cannot write to log'
			end
      end
      # verify the required parameter 'payment_instrument_token_id' is set
      if @api_client.config.client_side_validation && payment_instrument_token_id.nil?
        fail ArgumentError, "Missing the required parameter 'payment_instrument_token_id' when calling PaymentInstrumentApi.delete_payment_instrument"
      end
      if @api_client.config.client_side_validation && payment_instrument_token_id.to_s.length > 32
        fail ArgumentError, 'invalid value for "payment_instrument_token_id" when calling PaymentInstrumentApi.delete_payment_instrument, the character length must be smaller than or equal to 32.'
      end

      if @api_client.config.client_side_validation && payment_instrument_token_id.to_s.length < 1
        fail ArgumentError, 'invalid value for "payment_instrument_token_id" when calling PaymentInstrumentApi.delete_payment_instrument, the character length must be great than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'profile_id'].nil? && opts[:'profile_id'].to_s.length > 36
        fail ArgumentError, 'invalid value for "opts[:"profile_id"]" when calling PaymentInstrumentApi.delete_payment_instrument, the character length must be smaller than or equal to 36.'
      end

      if @api_client.config.client_side_validation && !opts[:'profile_id'].nil? && opts[:'profile_id'].to_s.length < 36
        fail ArgumentError, 'invalid value for "opts[:"profile_id"]" when calling PaymentInstrumentApi.delete_payment_instrument, the character length must be great than or equal to 36.'
      end

      # resource path
      local_var_path = 'tms/v1/paymentinstruments/{paymentInstrumentTokenId}'.sub('{' + 'paymentInstrumentTokenId' + '}', payment_instrument_token_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json;charset=utf-8'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json;charset=utf-8'])
      header_params[:'profile-id'] = opts[:'profile_id'] if !opts[:'profile_id'].nil?

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
		begin
		raise
			@api_client.config.logger.debug "API called: PaymentInstrumentApi#delete_payment_instrument\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
		rescue
			puts 'Cannot write to log'
		end
	  end
      return data, status_code, headers
    end
    # Retrieve a Payment Instrument
    # @param payment_instrument_token_id The TokenId of a payment instrument.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :profile_id The id of a profile containing user specific TMS configuration.
    # @return [Tmsv2customersEmbeddedDefaultPaymentInstrument]
    def get_payment_instrument(payment_instrument_token_id, opts = {})
      data, status_code, headers = get_payment_instrument_with_http_info(payment_instrument_token_id, opts)
      return data, status_code, headers
    end

    # Retrieve a Payment Instrument
    # @param payment_instrument_token_id The TokenId of a payment instrument.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :profile_id The id of a profile containing user specific TMS configuration.
    # @return [Array<(Tmsv2customersEmbeddedDefaultPaymentInstrument, Fixnum, Hash)>] Tmsv2customersEmbeddedDefaultPaymentInstrument data, response status code and response headers
    def get_payment_instrument_with_http_info(payment_instrument_token_id, opts = {})
      
	  if @api_client.config.debugging
	  	begin
			raise
				@api_client.config.logger.debug 'Calling API: PaymentInstrumentApi.get_payment_instrument ...'
			rescue
				puts 'Cannot write to log'
			end
      end
      # verify the required parameter 'payment_instrument_token_id' is set
      if @api_client.config.client_side_validation && payment_instrument_token_id.nil?
        fail ArgumentError, "Missing the required parameter 'payment_instrument_token_id' when calling PaymentInstrumentApi.get_payment_instrument"
      end
      if @api_client.config.client_side_validation && payment_instrument_token_id.to_s.length > 32
        fail ArgumentError, 'invalid value for "payment_instrument_token_id" when calling PaymentInstrumentApi.get_payment_instrument, the character length must be smaller than or equal to 32.'
      end

      if @api_client.config.client_side_validation && payment_instrument_token_id.to_s.length < 1
        fail ArgumentError, 'invalid value for "payment_instrument_token_id" when calling PaymentInstrumentApi.get_payment_instrument, the character length must be great than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'profile_id'].nil? && opts[:'profile_id'].to_s.length > 36
        fail ArgumentError, 'invalid value for "opts[:"profile_id"]" when calling PaymentInstrumentApi.get_payment_instrument, the character length must be smaller than or equal to 36.'
      end

      if @api_client.config.client_side_validation && !opts[:'profile_id'].nil? && opts[:'profile_id'].to_s.length < 36
        fail ArgumentError, 'invalid value for "opts[:"profile_id"]" when calling PaymentInstrumentApi.get_payment_instrument, the character length must be great than or equal to 36.'
      end

      # resource path
      local_var_path = 'tms/v1/paymentinstruments/{paymentInstrumentTokenId}'.sub('{' + 'paymentInstrumentTokenId' + '}', payment_instrument_token_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json;charset=utf-8'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json;charset=utf-8'])
      header_params[:'profile-id'] = opts[:'profile_id'] if !opts[:'profile_id'].nil?

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Tmsv2customersEmbeddedDefaultPaymentInstrument')
      if @api_client.config.debugging
		begin
		raise
			@api_client.config.logger.debug "API called: PaymentInstrumentApi#get_payment_instrument\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
		rescue
			puts 'Cannot write to log'
		end
	  end
      return data, status_code, headers
    end
    # Update a Payment Instrument
    # @param payment_instrument_token_id The TokenId of a payment instrument.
    # @param patch_payment_instrument_request 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :profile_id The id of a profile containing user specific TMS configuration.
    # @option opts [String] :if_match Contains an ETag value from a GET request to make the request conditional.
    # @return [Tmsv2customersEmbeddedDefaultPaymentInstrument]
    def patch_payment_instrument(payment_instrument_token_id, patch_payment_instrument_request, opts = {})
      data, status_code, headers = patch_payment_instrument_with_http_info(payment_instrument_token_id, patch_payment_instrument_request, opts)
      return data, status_code, headers
    end

    # Update a Payment Instrument
    # @param payment_instrument_token_id The TokenId of a payment instrument.
    # @param patch_payment_instrument_request 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :profile_id The id of a profile containing user specific TMS configuration.
    # @option opts [String] :if_match Contains an ETag value from a GET request to make the request conditional.
    # @return [Array<(Tmsv2customersEmbeddedDefaultPaymentInstrument, Fixnum, Hash)>] Tmsv2customersEmbeddedDefaultPaymentInstrument data, response status code and response headers
    def patch_payment_instrument_with_http_info(payment_instrument_token_id, patch_payment_instrument_request, opts = {})
      
	  if @api_client.config.debugging
	  	begin
			raise
				@api_client.config.logger.debug 'Calling API: PaymentInstrumentApi.patch_payment_instrument ...'
			rescue
				puts 'Cannot write to log'
			end
      end
      # verify the required parameter 'payment_instrument_token_id' is set
      if @api_client.config.client_side_validation && payment_instrument_token_id.nil?
        fail ArgumentError, "Missing the required parameter 'payment_instrument_token_id' when calling PaymentInstrumentApi.patch_payment_instrument"
      end
      if @api_client.config.client_side_validation && payment_instrument_token_id.to_s.length > 32
        fail ArgumentError, 'invalid value for "payment_instrument_token_id" when calling PaymentInstrumentApi.patch_payment_instrument, the character length must be smaller than or equal to 32.'
      end

      if @api_client.config.client_side_validation && payment_instrument_token_id.to_s.length < 1
        fail ArgumentError, 'invalid value for "payment_instrument_token_id" when calling PaymentInstrumentApi.patch_payment_instrument, the character length must be great than or equal to 1.'
      end

      # verify the required parameter 'patch_payment_instrument_request' is set
      if @api_client.config.client_side_validation && patch_payment_instrument_request.nil?
        fail ArgumentError, "Missing the required parameter 'patch_payment_instrument_request' when calling PaymentInstrumentApi.patch_payment_instrument"
      end
      if @api_client.config.client_side_validation && !opts[:'profile_id'].nil? && opts[:'profile_id'].to_s.length > 36
        fail ArgumentError, 'invalid value for "opts[:"profile_id"]" when calling PaymentInstrumentApi.patch_payment_instrument, the character length must be smaller than or equal to 36.'
      end

      if @api_client.config.client_side_validation && !opts[:'profile_id'].nil? && opts[:'profile_id'].to_s.length < 36
        fail ArgumentError, 'invalid value for "opts[:"profile_id"]" when calling PaymentInstrumentApi.patch_payment_instrument, the character length must be great than or equal to 36.'
      end

      if @api_client.config.client_side_validation && !opts[:'if_match'].nil? && opts[:'if_match'].to_s.length > 32
        fail ArgumentError, 'invalid value for "opts[:"if_match"]" when calling PaymentInstrumentApi.patch_payment_instrument, the character length must be smaller than or equal to 32.'
      end

      if @api_client.config.client_side_validation && !opts[:'if_match'].nil? && opts[:'if_match'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"if_match"]" when calling PaymentInstrumentApi.patch_payment_instrument, the character length must be great than or equal to 1.'
      end

      # resource path
      local_var_path = 'tms/v1/paymentinstruments/{paymentInstrumentTokenId}'.sub('{' + 'paymentInstrumentTokenId' + '}', payment_instrument_token_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json;charset=utf-8'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json;charset=utf-8'])
      header_params[:'profile-id'] = opts[:'profile_id'] if !opts[:'profile_id'].nil?
      header_params[:'if-match'] = opts[:'if_match'] if !opts[:'if_match'].nil?

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(patch_payment_instrument_request)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Tmsv2customersEmbeddedDefaultPaymentInstrument')
      if @api_client.config.debugging
		begin
		raise
			@api_client.config.logger.debug "API called: PaymentInstrumentApi#patch_payment_instrument\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
		rescue
			puts 'Cannot write to log'
		end
	  end
      return data, status_code, headers
    end
    # Create a Payment Instrument
    # Include an existing TMS Instrument Identifier id in the request body. * An Instrument Identifier token can be created by calling: **POST */tms/v1/instrumentidentifiers*** 
    # @param post_payment_instrument_request 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :profile_id The id of a profile containing user specific TMS configuration.
    # @return [Tmsv2customersEmbeddedDefaultPaymentInstrument]
    def post_payment_instrument(post_payment_instrument_request, opts = {})
      data, status_code, headers = post_payment_instrument_with_http_info(post_payment_instrument_request, opts)
      return data, status_code, headers
    end

    # Create a Payment Instrument
    # Include an existing TMS Instrument Identifier id in the request body. * An Instrument Identifier token can be created by calling: **POST */tms/v1/instrumentidentifiers*** 
    # @param post_payment_instrument_request 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :profile_id The id of a profile containing user specific TMS configuration.
    # @return [Array<(Tmsv2customersEmbeddedDefaultPaymentInstrument, Fixnum, Hash)>] Tmsv2customersEmbeddedDefaultPaymentInstrument data, response status code and response headers
    def post_payment_instrument_with_http_info(post_payment_instrument_request, opts = {})
      
	  if @api_client.config.debugging
	  	begin
			raise
				@api_client.config.logger.debug 'Calling API: PaymentInstrumentApi.post_payment_instrument ...'
			rescue
				puts 'Cannot write to log'
			end
      end
      # verify the required parameter 'post_payment_instrument_request' is set
      if @api_client.config.client_side_validation && post_payment_instrument_request.nil?
        fail ArgumentError, "Missing the required parameter 'post_payment_instrument_request' when calling PaymentInstrumentApi.post_payment_instrument"
      end
      if @api_client.config.client_side_validation && !opts[:'profile_id'].nil? && opts[:'profile_id'].to_s.length > 36
        fail ArgumentError, 'invalid value for "opts[:"profile_id"]" when calling PaymentInstrumentApi.post_payment_instrument, the character length must be smaller than or equal to 36.'
      end

      if @api_client.config.client_side_validation && !opts[:'profile_id'].nil? && opts[:'profile_id'].to_s.length < 36
        fail ArgumentError, 'invalid value for "opts[:"profile_id"]" when calling PaymentInstrumentApi.post_payment_instrument, the character length must be great than or equal to 36.'
      end

      # resource path
      local_var_path = 'tms/v1/paymentinstruments'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json;charset=utf-8'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json;charset=utf-8'])
      header_params[:'profile-id'] = opts[:'profile_id'] if !opts[:'profile_id'].nil?

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(post_payment_instrument_request)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Tmsv2customersEmbeddedDefaultPaymentInstrument')
      if @api_client.config.debugging
		begin
		raise
			@api_client.config.logger.debug "API called: PaymentInstrumentApi#post_payment_instrument\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
		rescue
			puts 'Cannot write to log'
		end
	  end
      return data, status_code, headers
    end
  end
end
