=begin
#CyberSource Merged Spec

#All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html

OpenAPI spec version: 0.0.1

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.2.3

=end

require 'date'

module CyberSource
  class Ptsv2paymentsRiskInformationBuyerHistory
    attr_accessor :customer_account

    attr_accessor :account_history

    # Number of purchases with this cardholder account during the previous six months. Recommended for Discover ProtectBuy. 
    attr_accessor :account_purchases

    # Number of add card attempts in the last 24 hours. Recommended for Discover ProtectBuy. 
    attr_accessor :add_card_attempts

    # Indicates whether the merchant experienced suspicious activity (including previous fraud) on the account. Recommended for Discover ProtectBuy. 
    attr_accessor :prior_suspicious_activity

    # This only applies for NEW_ACCOUNT and EXISTING_ACCOUNT in creationHistory. Possible values are: - PAYMENT_ACCOUNT_EXISTS - PAYMENT_ACCOUNT_ADDED_NOW 
    attr_accessor :payment_account_history

    # Date applicable only for PAYMENT_ACCOUNT_EXISTS in paymentAccountHistory 
    attr_accessor :payment_account_date

    # Number of transaction (successful or abandoned) for this cardholder account within the last 24 hours. Recommended for Discover ProtectBuy. 
    attr_accessor :transaction_count_day

    # Number of transaction (successful or abandoned) for this cardholder account within the last year. Recommended for Discover ProtectBuy. 
    attr_accessor :transaction_count_year

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'customer_account' => :'customerAccount',
        :'account_history' => :'accountHistory',
        :'account_purchases' => :'accountPurchases',
        :'add_card_attempts' => :'addCardAttempts',
        :'prior_suspicious_activity' => :'priorSuspiciousActivity',
        :'payment_account_history' => :'paymentAccountHistory',
        :'payment_account_date' => :'paymentAccountDate',
        :'transaction_count_day' => :'transactionCountDay',
        :'transaction_count_year' => :'transactionCountYear'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'customer_account' => :'Ptsv2paymentsRiskInformationBuyerHistoryCustomerAccount',
        :'account_history' => :'Ptsv2paymentsRiskInformationBuyerHistoryAccountHistory',
        :'account_purchases' => :'Integer',
        :'add_card_attempts' => :'Integer',
        :'prior_suspicious_activity' => :'BOOLEAN',
        :'payment_account_history' => :'String',
        :'payment_account_date' => :'Integer',
        :'transaction_count_day' => :'Integer',
        :'transaction_count_year' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'customerAccount')
        self.customer_account = attributes[:'customerAccount']
      end

      if attributes.has_key?(:'accountHistory')
        self.account_history = attributes[:'accountHistory']
      end

      if attributes.has_key?(:'accountPurchases')
        self.account_purchases = attributes[:'accountPurchases']
      end

      if attributes.has_key?(:'addCardAttempts')
        self.add_card_attempts = attributes[:'addCardAttempts']
      end

      if attributes.has_key?(:'priorSuspiciousActivity')
        self.prior_suspicious_activity = attributes[:'priorSuspiciousActivity']
      end

      if attributes.has_key?(:'paymentAccountHistory')
        self.payment_account_history = attributes[:'paymentAccountHistory']
      end

      if attributes.has_key?(:'paymentAccountDate')
        self.payment_account_date = attributes[:'paymentAccountDate']
      end

      if attributes.has_key?(:'transactionCountDay')
        self.transaction_count_day = attributes[:'transactionCountDay']
      end

      if attributes.has_key?(:'transactionCountYear')
        self.transaction_count_year = attributes[:'transactionCountYear']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          customer_account == o.customer_account &&
          account_history == o.account_history &&
          account_purchases == o.account_purchases &&
          add_card_attempts == o.add_card_attempts &&
          prior_suspicious_activity == o.prior_suspicious_activity &&
          payment_account_history == o.payment_account_history &&
          payment_account_date == o.payment_account_date &&
          transaction_count_day == o.transaction_count_day &&
          transaction_count_year == o.transaction_count_year
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [customer_account, account_history, account_purchases, add_card_attempts, prior_suspicious_activity, payment_account_history, payment_account_date, transaction_count_day, transaction_count_year].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = CyberSource.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
