=begin
#CyberSource Merged Spec

#All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html

OpenAPI spec version: 0.0.1

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.2.3

=end

require 'date'

module CyberSource
  class Ptsv2paymentsidcapturesProcessingInformationCaptureOptions
    # Capture number when requesting multiple partial captures for one authorization. Used along with `totalCaptureCount` to track which capture is being processed.  For example, the second of five captures would be passed to CyberSource as:   - `captureSequenceNumber_ = 2`, and   - `totalCaptureCount = 5` 
    attr_accessor :capture_sequence_number

    # Total number of captures when requesting multiple partial captures for one payment. Used along with `captureSequenceNumber` field to track which capture is being processed.  For example, the second of five captures would be passed to CyberSource as:   - `captureSequenceNumber = 2`, and   - `totalCaptureCount = 5` 
    attr_accessor :total_capture_count

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'capture_sequence_number' => :'captureSequenceNumber',
        :'total_capture_count' => :'totalCaptureCount'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'capture_sequence_number' => :'Integer',
        :'total_capture_count' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'captureSequenceNumber')
        self.capture_sequence_number = attributes[:'captureSequenceNumber']
      end

      if attributes.has_key?(:'totalCaptureCount')
        self.total_capture_count = attributes[:'totalCaptureCount']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@capture_sequence_number.nil? && @capture_sequence_number > 99
        invalid_properties.push('invalid value for "capture_sequence_number", must be smaller than or equal to 99.')
      end

      if !@capture_sequence_number.nil? && @capture_sequence_number < 1
        invalid_properties.push('invalid value for "capture_sequence_number", must be greater than or equal to 1.')
      end

      if !@total_capture_count.nil? && @total_capture_count > 99
        invalid_properties.push('invalid value for "total_capture_count", must be smaller than or equal to 99.')
      end

      if !@total_capture_count.nil? && @total_capture_count < 1
        invalid_properties.push('invalid value for "total_capture_count", must be greater than or equal to 1.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@capture_sequence_number.nil? && @capture_sequence_number > 99
      return false if !@capture_sequence_number.nil? && @capture_sequence_number < 1
      return false if !@total_capture_count.nil? && @total_capture_count > 99
      return false if !@total_capture_count.nil? && @total_capture_count < 1
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] capture_sequence_number Value to be assigned
    def capture_sequence_number=(capture_sequence_number)
      if !capture_sequence_number.nil? && capture_sequence_number > 99
        fail ArgumentError, 'invalid value for "capture_sequence_number", must be smaller than or equal to 99.'
      end

      if !capture_sequence_number.nil? && capture_sequence_number < 1
        fail ArgumentError, 'invalid value for "capture_sequence_number", must be greater than or equal to 1.'
      end

      @capture_sequence_number = capture_sequence_number
    end

    # Custom attribute writer method with validation
    # @param [Object] total_capture_count Value to be assigned
    def total_capture_count=(total_capture_count)
      if !total_capture_count.nil? && total_capture_count > 99
        fail ArgumentError, 'invalid value for "total_capture_count", must be smaller than or equal to 99.'
      end

      if !total_capture_count.nil? && total_capture_count < 1
        fail ArgumentError, 'invalid value for "total_capture_count", must be greater than or equal to 1.'
      end

      @total_capture_count = total_capture_count
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          capture_sequence_number == o.capture_sequence_number &&
          total_capture_count == o.total_capture_count
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [capture_sequence_number, total_capture_count].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = CyberSource.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
