=begin
#CyberSource Merged Spec

#All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html

OpenAPI spec version: 0.0.1

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.2.3

=end

require 'date'

module CyberSource
  # Subscription Details
  class ReportingV3ReportSubscriptionsGet200ResponseSubscriptions
    # Selected Organization Id
    attr_accessor :organization_id

    # Report Definition Id
    attr_accessor :report_definition_id

    # Report Definition Class
    attr_accessor :report_definition_name

    # Report Format                          Valid values: - application/xml - text/csv 
    attr_accessor :report_mime_type

    # 'Report Frequency' **NOTE: Do not document USER_DEFINED Frequency field in developer center**  Valid values: - DAILY - WEEKLY - MONTHLY - USER_DEFINED 
    attr_accessor :report_frequency

    # If the reportFrequency is User-defined, reportInterval should be in **ISO 8601 time format** Please refer the following link to know more about ISO 8601 format.[Rfc Time Format](https://en.wikipedia.org/wiki/ISO_8601#Durations)  **Example time format for 2 hours and 30 Mins:**   - PT2H30M **NOTE: Do not document reportInterval field in developer center** 
    attr_accessor :report_interval

    # Report Name
    attr_accessor :report_name

    # Time Zone
    attr_accessor :timezone

    # Start Time
    attr_accessor :start_time

    # Start Day
    attr_accessor :start_day

    # List of all fields String values
    attr_accessor :report_fields

    # List of filters to apply
    attr_accessor :report_filters

    attr_accessor :report_preferences

    # Id for the selected group.
    attr_accessor :group_id

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'organization_id' => :'organizationId',
        :'report_definition_id' => :'reportDefinitionId',
        :'report_definition_name' => :'reportDefinitionName',
        :'report_mime_type' => :'reportMimeType',
        :'report_frequency' => :'reportFrequency',
        :'report_interval' => :'reportInterval',
        :'report_name' => :'reportName',
        :'timezone' => :'timezone',
        :'start_time' => :'startTime',
        :'start_day' => :'startDay',
        :'report_fields' => :'reportFields',
        :'report_filters' => :'reportFilters',
        :'report_preferences' => :'reportPreferences',
        :'group_id' => :'groupId'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'organization_id' => :'String',
        :'report_definition_id' => :'String',
        :'report_definition_name' => :'String',
        :'report_mime_type' => :'String',
        :'report_frequency' => :'String',
        :'report_interval' => :'String',
        :'report_name' => :'String',
        :'timezone' => :'String',
        :'start_time' => :'DateTime',
        :'start_day' => :'Integer',
        :'report_fields' => :'Array<String>',
        :'report_filters' => :'Hash<String, Array<String>>',
        :'report_preferences' => :'Reportingv3reportsReportPreferences',
        :'group_id' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'organizationId')
        self.organization_id = attributes[:'organizationId']
      end

      if attributes.has_key?(:'reportDefinitionId')
        self.report_definition_id = attributes[:'reportDefinitionId']
      end

      if attributes.has_key?(:'reportDefinitionName')
        self.report_definition_name = attributes[:'reportDefinitionName']
      end

      if attributes.has_key?(:'reportMimeType')
        self.report_mime_type = attributes[:'reportMimeType']
      end

      if attributes.has_key?(:'reportFrequency')
        self.report_frequency = attributes[:'reportFrequency']
      end

      if attributes.has_key?(:'reportInterval')
        self.report_interval = attributes[:'reportInterval']
      end

      if attributes.has_key?(:'reportName')
        self.report_name = attributes[:'reportName']
      end

      if attributes.has_key?(:'timezone')
        self.timezone = attributes[:'timezone']
      end

      if attributes.has_key?(:'startTime')
        self.start_time = attributes[:'startTime']
      end

      if attributes.has_key?(:'startDay')
        self.start_day = attributes[:'startDay']
      end

      if attributes.has_key?(:'reportFields')
        if (value = attributes[:'reportFields']).is_a?(Array)
          self.report_fields = value
        end
      end

      if attributes.has_key?(:'reportFilters')
        if (value = attributes[:'reportFilters']).is_a?(Hash)
          self.report_filters = value
        end
      end

      if attributes.has_key?(:'reportPreferences')
        self.report_preferences = attributes[:'reportPreferences']
      end

      if attributes.has_key?(:'groupId')
        self.group_id = attributes[:'groupId']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      #if !@report_interval.nil? && @report_interval !~ Regexp.new(/^PT((([1-9]|1[0-9]|2[0-3])H(([1-9]|[1-4][0-9]|5[0-9])M)?)|((([1-9]|1[0-9]|2[0-3])H)?([1-9]|[1-4][0-9]|5[0-9])M))$/)
        #invalid_properties.push('invalid value for "report_interval", must conform to the pattern /^PT((([1-9]|1[0-9]|2[0-3])H(([1-9]|[1-4][0-9]|5[0-9])M)?)|((([1-9]|1[0-9]|2[0-3])H)?([1-9]|[1-4][0-9]|5[0-9])M))$/.')
      #end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      #return false if !@report_interval.nil? && @report_interval !~ Regexp.new(/^PT((([1-9]|1[0-9]|2[0-3])H(([1-9]|[1-4][0-9]|5[0-9])M)?)|((([1-9]|1[0-9]|2[0-3])H)?([1-9]|[1-4][0-9]|5[0-9])M))$/)
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] report_interval Value to be assigned
    def report_interval=(report_interval)
      #if !report_interval.nil? && report_interval !~ Regexp.new(/^PT((([1-9]|1[0-9]|2[0-3])H(([1-9]|[1-4][0-9]|5[0-9])M)?)|((([1-9]|1[0-9]|2[0-3])H)?([1-9]|[1-4][0-9]|5[0-9])M))$/)
        #fail ArgumentError, 'invalid value for "report_interval", must conform to the pattern /^PT((([1-9]|1[0-9]|2[0-3])H(([1-9]|[1-4][0-9]|5[0-9])M)?)|((([1-9]|1[0-9]|2[0-3])H)?([1-9]|[1-4][0-9]|5[0-9])M))$/.'
      #end

      @report_interval = report_interval
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          organization_id == o.organization_id &&
          report_definition_id == o.report_definition_id &&
          report_definition_name == o.report_definition_name &&
          report_mime_type == o.report_mime_type &&
          report_frequency == o.report_frequency &&
          report_interval == o.report_interval &&
          report_name == o.report_name &&
          timezone == o.timezone &&
          start_time == o.start_time &&
          start_day == o.start_day &&
          report_fields == o.report_fields &&
          report_filters == o.report_filters &&
          report_preferences == o.report_preferences &&
          group_id == o.group_id
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [organization_id, report_definition_id, report_definition_name, report_mime_type, report_frequency, report_interval, report_name, timezone, start_time, start_day, report_fields, report_filters, report_preferences, group_id].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = CyberSource.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
