=begin
#CyberSource Merged Spec

#All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html

OpenAPI spec version: 0.0.1

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.2.3

=end

require 'date'

module CyberSource
  class Vasv2taxOrderInformation
    attr_accessor :amount_details

    attr_accessor :bill_to

    attr_accessor :shipping_details

    attr_accessor :ship_to

    attr_accessor :line_items

    attr_accessor :invoice_details

    attr_accessor :order_acceptance

    attr_accessor :order_origin

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'amount_details' => :'amountDetails',
        :'bill_to' => :'billTo',
        :'shipping_details' => :'shippingDetails',
        :'ship_to' => :'shipTo',
        :'line_items' => :'lineItems',
        :'invoice_details' => :'invoiceDetails',
        :'order_acceptance' => :'orderAcceptance',
        :'order_origin' => :'orderOrigin'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'amount_details' => :'RiskV1DecisionsPost201ResponseOrderInformationAmountDetails',
        :'bill_to' => :'Vasv2taxOrderInformationBillTo',
        :'shipping_details' => :'Vasv2taxOrderInformationShippingDetails',
        :'ship_to' => :'Vasv2taxOrderInformationShipTo',
        :'line_items' => :'Array<Vasv2taxOrderInformationLineItems>',
        :'invoice_details' => :'Vasv2taxOrderInformationInvoiceDetails',
        :'order_acceptance' => :'Vasv2taxOrderInformationOrderAcceptance',
        :'order_origin' => :'Vasv2taxOrderInformationOrderOrigin'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'amountDetails')
        self.amount_details = attributes[:'amountDetails']
      end

      if attributes.has_key?(:'billTo')
        self.bill_to = attributes[:'billTo']
      end

      if attributes.has_key?(:'shippingDetails')
        self.shipping_details = attributes[:'shippingDetails']
      end

      if attributes.has_key?(:'shipTo')
        self.ship_to = attributes[:'shipTo']
      end

      if attributes.has_key?(:'lineItems')
        if (value = attributes[:'lineItems']).is_a?(Array)
          self.line_items = value
        end
      end

      if attributes.has_key?(:'invoiceDetails')
        self.invoice_details = attributes[:'invoiceDetails']
      end

      if attributes.has_key?(:'orderAcceptance')
        self.order_acceptance = attributes[:'orderAcceptance']
      end

      if attributes.has_key?(:'orderOrigin')
        self.order_origin = attributes[:'orderOrigin']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          amount_details == o.amount_details &&
          bill_to == o.bill_to &&
          shipping_details == o.shipping_details &&
          ship_to == o.ship_to &&
          line_items == o.line_items &&
          invoice_details == o.invoice_details &&
          order_acceptance == o.order_acceptance &&
          order_origin == o.order_origin
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [amount_details, bill_to, shipping_details, ship_to, line_items, invoice_details, order_acceptance, order_origin].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = CyberSource.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
